from ripser import ripser
import matplotlib.pyplot as plt
import numpy as np
from scipy import integrate
import graph_tool.all as gt
import random
import traces


def make_filtration_matrix(G):
    """
    Takes in adjacency matrix and returns a filtration matrix for Ripser
    """
    
    n = G.shape[0]
    weighted_G = np.ones([n, n])
    for col in range(n):
        weighted_G[:col, col] = weighted_G[:col, col] * col
        weighted_G[col, :col] = weighted_G[col, :col] * col
    weighted_G += 1
    # weighted_G = G * weighted_G
    weighted_G = np.multiply(G, weighted_G)
    np.fill_diagonal(weighted_G, list(range(1, n + 1)))
    weighted_G[weighted_G == 0] = np.inf
    
    return weighted_G

def get_barcode(filt_mat, maxdim = 1):
    """
    Calculates the persistent homology for a given filtration matrix
    ``filt_mat``, default dimensions 0 through 1. Wraps Ripser.
    """
    
    b = ripser(filt_mat, distance_matrix = True, maxdim = maxdim)['dgms']
    
    return list(zip(range(maxdim + 1), b))

def betti_curves(bars, length):
    """
    Takes in bars and returns the betti curves
    """
    
    bettis = np.zeros((len(bars), length))
    for i in range(bettis.shape[0]):
        bn = bars[i][1]
        for bar in bn:
            birth = int(bar[0])
            death = length+1 if np.isinf(bar[1]) else int(bar[1]+1)
            bettis[i][birth:death] += 1
            
    return bettis

def plot_barcode(bars, length, dims = [0, 1], end = True):
    """
    Takes in bars, as generated by, e.g., ripser, and plots the barcode.
    """
    
    bars = dict(bars)
    count = 1
    has_inf = False
    colors = ['xkcd:emerald green', 'xkcd:tealish', 'xkcd:peacock blue']
    # iterate through dimension
    for d in dims:
        bn = bars[d]
        bn = sorted(bn, key = lambda x: x[0])
        for b, i in zip(bn, range(len(bn))):
            # extend in the case of infinite cycles
            if b[1] == np.inf:
                has_inf = True
                b = (b[0], 1.3*length)
            # plot first one with label
            if i == 0:
                plt.plot(b, [count, count], color = colors[d],
                         label='{}-cycles'.format(d))
            else:
                plt.plot(b, [count, count], color = colors[d])
            count += 1
        count += 1
    # add end of filtration line
    plt.axvline(x = length, color = 'xkcd:grey', alpha = 0.5, linestyle = ':')
    if end:
        plt.annotate('Filtration End', (length + 10, 0.5 * count), rotation = 270,
                     color = 'xkcd:grey', alpha = 0.5)
    lims = plt.xlim()
    plt.xlim([-0.05 * length, length * 1.05])
    plt.xlabel('Nodes')
    plt.ylabel('Cycle Number')
    
def compute_mechanical_features(G):
    """
    Takes in adjacency matrix and returns mechanical features for corresponding filtration
    """
    
    d = []
    conform = []
    curr_d = 1
    for i in range(1, G.shape[0] + 1):
        G_filt = G[:i, :i] # current subgraph in growing graph
        num_nodes = G_filt.shape[0] # current number of nodes
        num_edges = np.count_nonzero(np.triu(G_filt)) # current number of edges
        curr_DoF = (curr_d * num_nodes) - num_edges # constraint counting
        curr_rigid = curr_d * (curr_d + 1)/2
        while curr_DoF - curr_rigid < 0:
            curr_d += 1 # increment embedding dimension
            curr_DoF = (curr_d * num_nodes) - num_edges # constraint counting
            curr_rigid = curr_d * (curr_d + 1)/2
        d.append(curr_d)
        conform.append(curr_DoF - curr_rigid) # DoF = rigid + conform
        
    return [d, conform]

def compute_filtration_MDL(G):
    """
    Takes in adjacency matrix and returns MDL for corresponding filtration
    """
    
    MDL = []
    for i in range(1, G.shape[0] + 1):
        G_filt = gt.Graph(directed = False) # create graph-tool graph object for subgraph
        G_filt.add_edge_list(np.transpose(np.triu(G[:i, :i]).nonzero()))
        if len(list(G_filt.edges())) == 0: # if there are no edges so far then skip this subgraph
            MDL.append(np.NaN)
            continue
        state = gt.minimize_nested_blockmodel_dl(G_filt) # fit hierarchical block model
        for i in range(5):
            ret = state.multiflip_mcmc_sweep(niter = 5, beta = np.inf)
        MDL.append(state.entropy()) # minimum description length for subgraph
    
    return MDL

def time_normalize_and_merge(timeseries_lst, make_1_1 = False):
    """
    Takes in a list of time series (of possibly different lengths) and
    subsamples them using traces so they all range from 0 and 1 and are defined
    on the same points.
    """
    
    n_series = len(timeseries_lst)
    timeseries_lst = [traces.TimeSeries(zip(*(np.linspace(0, 1, len(ts)), ts)))
                      for ts in timeseries_lst]
    timeseries_lst = traces.TimeSeries.merge(timeseries_lst)
    if make_1_1:
        timeseries_lst[1.0] = [1.0] * n_series
    X = list(zip(*timeseries_lst.items()))[0]  # x values
    Y = list(zip(*timeseries_lst.items()))[1]  # y values across all series
    
    return X, Y

def plot_curve(curves_lst, curve_label = 'none', curve_color = 'none'):
    """
    Accepts a list of curves and the identity of the null model used if the data 
    come from one; curve_label and curve_color arguments are used for plotting.
    Plots average curve with a standard deviation/error band. 
    """
    
    max_nodes = max([len(lst) for lst in curves_lst])
    curves_mat = np.empty([len(curves_lst), max_nodes])
    curves_mat[:] = np.nan
    for i, j in enumerate(curves_lst):
        curves_mat[i][0:len(j)] = j
    numels = np.count_nonzero(~np.isnan(curves_mat), axis = 0)
    mean = np.nanmean(curves_mat, axis = 0)[numels > 1]
    std = np.nanstd(curves_mat, axis = 0)[numels > 1]
    # mins = mean - std
    mins = mean - np.divide(std, np.sqrt(numels[numels > 1]))
    mins = np.maximum(0, mins)
    # maxes = mean + std
    maxes = mean + np.divide(std, np.sqrt(numels[numels > 1]))
    X = np.arange(len(numels[numels > 1]))
    plt.plot(X, mean, color = curve_color, label = curve_label,
            linewidth = 1)
    plt.fill_between(X, mins, maxes, facecolor = curve_color, alpha = 0.2)
    
    return X, mean


def plot_curve_normalized_idx(curves_lst, curve_label = 'none', curve_color = 'none'):
    """
    Accepts a list of curves and the identity of the null model used if the data 
    come from one; curve_label and curve_color arguments are used for plotting.
    Plots average curve with a standard deviation/error band, and with the 
    horizontal axis normalized to be [0, 1].
    """
    
    X, Y = time_normalize_and_merge(curves_lst)
    mean = np.nanmean(Y, axis = 1)
    # mins = np.nanmean(Y, axis = 1) - np.nanstd(Y, axis = 1)
    mins = np.nanmean(Y, axis = 1) - np.nanstd(Y, axis = 1)/np.sqrt(len(curves_lst))
    mins = np.maximum(0, mins)
    # maxes = np.nanmean(Y, axis = 1) + np.nanstd(Y, axis = 1)
    maxes = np.nanmean(Y, axis = 1) + np.nanstd(Y, axis = 1)/np.sqrt(len(curves_lst))
    plt.plot(X, mean, color = curve_color, label = curve_label, linewidth = 1)
    plt.fill_between(X, mins, maxes, facecolor = curve_color, alpha = 0.2)
    
    return X, mean

def area_under_curve(x, y):
    
    y_keep = y[~np.isnan(y)]
    x_keep = np.array(x)[~np.isnan(y)]
    area = integrate.trapz(y_keep, x_keep) # area under curve
    
    return area

def permutation_testing(x_1, mean_1, x_2, mean_2):
    
    y_empirical = mean_1[~np.isnan(mean_1)]
    x_empirical = np.array(x_1)[~np.isnan(mean_1)]
    area_empirical = integrate.trapz(y_empirical, x_empirical) # empirical
    y_null = mean_2[~np.isnan(mean_2)]
    x_null = np.array(x_2)[~np.isnan(mean_2)]
    area_null = integrate.trapz(y_null, x_null) # null
    area_difference = np.abs(area_empirical - area_null)
    empirical_group_size = len(x_empirical)
    null_group_size = len(x_null)
    all_data = list(zip(mean_1, x_1)) + list(zip(mean_2, x_2))
    number_of_permutations = 1000
    counter = 0
    for i in range(number_of_permutations):
        random.shuffle(all_data) # shuffle the data
        new_empirical = sorted(all_data[:empirical_group_size], key = lambda x: x[1])
        new_null = sorted(all_data[empirical_group_size:], key = lambda x: x[1])
        unzip_new_empirical = list(zip(*new_empirical))
        y_empirical_new = unzip_new_empirical[0]
        x_empirical_new = unzip_new_empirical[1]
        area_empirical_new = integrate.trapz(y_empirical_new, x_empirical_new) # empirical new
        unzip_new_null = list(zip(*new_null))
        y_null_new = unzip_new_null[0]
        x_null_new = unzip_new_null[1]
        area_null_new = integrate.trapz(y_null_new, x_null_new) # null new
        area_difference_permuted = np.abs(area_empirical_new - area_null_new)
        if area_difference_permuted > area_difference:
            counter += 1
    p_value = counter/number_of_permutations
    
    return p_value